<?php
require_once $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/main/include/prolog_admin_before.php";
require_once $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/subscribe/include.php";
require_once $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/subscribe/prolog.php";

IncludeModuleLangFile(__FILE__);

$APPLICATION->SetTitle(GetMessage('BIFIT_REPORTS_TITLE'));

if (!CModule::IncludeModule("bifit.kassa")) {
	ShowError(GetMessage('BIFIT_REPORTS_MODULE_INCLUDE_ERROR'));
	require $_SERVER["DOCUMENT_ROOT"] .
		"/bitrix/modules/main/include/epilog_admin.php";
}

$sTableID = "b_bifit_kassa_reports";
$oSort = new CAdminSorting($sTableID, "ID", "desc");
$lAdmin = new CAdminList($sTableID, $oSort);

CUtil::InitJSCore(array('ajax', 'jquery', 'popup'));

// ******************************************************************** //
//                PROCESSING ACTIONS ON LIST ELEMENTS                   //
// ******************************************************************** //

if ($arID = $lAdmin->GroupAction()) {
	if ($_REQUEST['action_target'] == 'selected') {
		$cData = new BifitKassaReportsTable();
		$rsData = $cData->GetList(
			array(
				$by => $order
			),
			$arFilter
		);

		while ($arRes = $rsData->Fetch()) {
			$arID[] = $arRes['ID'];
		}
	}

	foreach ($arID as $ID) {
		if (strlen($ID) <= 0) {
			continue;
		}

		$ID = IntVal($ID);

		switch ($_REQUEST['action']) {
			case "delete":
				@set_time_limit(0);
				$DB->StartTransaction();

				if (!BifitKassaReportsTable::Delete($ID)) {
					$DB->Rollback();
					$lAdmin->AddGroupError(GetMessage("rub_del_err"), $ID);
				}

				$DB->Commit();
				break;
		}
	}
}

// temp
$session = \Bitrix\Main\Application::getInstance()->getSession();
if ($session->has('bifit_acts')) {
	$arr = $session->get('bifit_acts');
	echo implode(',',$arr) . "<br>";
	if (is_array($arr) && count($arr)) {
		foreach ($arr as $k=>$v) {
			$a_n = 'bifit_act_' . $v;
			if ($session->has($a_n)) {
				$todel = '';
				if (
					strtotime(date("Y-m-d H:i:s")) > 
					$session->get($a_n)
				) {
					$todel = '[к удалению]';

				}
				echo $a_n . ' = ' . date("Y-m-d H:i:s", $session->get($a_n)) . " " . $todel . "<br>";
			}
		}
	}
}

// ******************************************************************** //
//                     SELECTED LIST ITEMS                              //
// ******************************************************************** //

$rsData = BifitKassaReportsTable::getList(array(
	'order' => array(
		'ID' => 'DESC'
	),
	'offset' => $offset,
	'limit' => $limit
));
$rsData = new CAdminResult($rsData, $sTableID);
$rsData->NavStart();

$lAdmin->NavText($rsData->GetNavPrint(GetMessage("rub_nav")));

// ******************************************************************** //
//                PREPARING THE LIST FOR OUTPUT                         //
// ******************************************************************** //

$lAdmin->AddHeaders(array(
	array(
		"id" => 'id',
		"content" => GetMessage('BIFIT_REPORTS_ITEM_ID'),
		"default" => true
	),
	array(
		"id" => 'order_id',
		"content" => GetMessage('BIFIT_REPORTS_ITEM_ORDER_ID'),
		"default" => true
	),
	array(
		"id" => 'order_number',
		"content" => GetMessage('BIFIT_REPORTS_ITEM_ORDER_NUMBER'),
		"default" => true
	),
	array(
		"id" => 'order_date',
		"content" => GetMessage('BIFIT_ORDER_DATE'),
		"default" => true
	),
	array(
		"id" => 'action_date',
		"content" => GetMessage('BIFIT_ACTION_DATE'),
		"default" => true
	),
	array(
		"id" => 'receipt_link',
		"content" => GetMessage('BIFIT_RECEIPT'),
		"default" => true
	),
	array(
		"id" => 'doc',
		"content" => GetMessage('BIFIT_DOCUMENT'),
		"default" => true
	),
	array(
		"id" => 'log',
		"content" => GetMessage('BIFIT_LOG'),
		"default" => true
	),
	array(
		"id" => 'receipt_type',
		"content" => GetMessage('BIFIT_TYPE'),
		"default" => true
	)
));

while ($arRes = $rsData->NavNext(true)) {
	$row = &$lAdmin->AddRow($arRes['ID'], array(
		'id' => $arRes['ID'],
		'order_id' => $arRes['ORDER_ID'],
		'order_number' => $arRes['ORDER_NUMBER'],
		'order_date' => $arRes['ORDER_DATE'],
		'action_date' => $arRes['ACTION_DATE'],
		'receipt_link' => $arRes['RECEIPT_LINK'],
		'receipt_id' => $arRes['RECEIPT_ID'],
		'log' => $arRes['LOG'],
		'receipt_type' => $arRes['RECEIPT_TYPE']
	));

	$text_log =
		'<div style="width:600px;overflow-y:scroll">' .
		str_replace("\n", "<br>", $arRes['LOG']) .
		"</div>";

	$row->AddInputField("order_id", array("size" => 20));
	$row->AddViewField(
		"order_id",
		'<a target="_blank" class="bifit_edit_btn adm-btn" href="/bitrix/admin/sale_order_view.php?ID=' .
			$arRes['ORDER_ID'] .
			'&lang=ru&filter=Y&set_filter=Y" title="' .
			GetMessage('BIFIT_CHANGE_ORDER_PARAMS') .
			'">#' .
			$arRes['ORDER_ID'] .
			'</a>'
	);
	$row->AddViewField("order_number", '№' . $arRes['ORDER_NUMBER']);
	$row->AddInputField("receipt_link", array("size" => 20));
	$row->AddViewField(
		"receipt_link",
		$arRes['RECEIPT_ID'] > 0
			? '<a target="_blank" class="bifit_update_btn adm-btn" href="' .
				$arRes['RECEIPT_LINK'] .
				'">' .
				GetMessage('BIFIT_OPEN') .
				'</a>'
			: '<span class="error">' . GetMessage('BIFIT_NONE_SM') . '</span>'
	);
	$row->AddInputField("doc", array("size" => 20));
	$row->AddViewField(
		"doc",
		$arRes['RECEIPT_ID'] > 0
			? '<span class="success">' . $arRes['RECEIPT_ID'] . '</span>'
			: '<span class="error">' . GetMessage('BIFIT_NONE_SM') . '</span>'
	);
	$row->AddInputField("log", array("size" => 20));
	$row->AddViewField(
		"log",
		'
<a id="showlog' .
			$arRes['ID'] .
			'" class="bifit_update_btn adm-btn" href="#log' .
			$arRes['ID'] .
			'">' .
			GetMessage('BIFIT_VIEW') .
			'</a>
<script type="text/javascript">
var addlog' .
			$arRes['ID'] .
			' = new BX.PopupWindow(
	"addlog' .
			$arRes['ID'] .
			'",
	null, 
	{
		content: \'' .
			addslashes($text_log) .
			'\',
		closeIcon: {
			right: "20px", 
			top: "10px"
		},
		titleBar: {
			content: BX.create("h3", {
				html: "' .
			GetMessage('BIFIT_LOG') .
			'", \'props\': {\'className\': \'access-title-bar\'}
			})
		}, 
		zIndex: 0,
		offsetLeft: 0,
		offsetTop: 0,
		draggable: {
			restrict: false
		},
		buttons: [
			new BX.PopupWindowButton({
				text: "' . 
				GetMessage('BIFIT_CLOSE') . 
				'", className: "webform-button-link-cancel",
				events: {
					click: function() {
						this.popupWindow.close();
					}
				}
			})
		]
	}
);
$(\'#showlog' .
			$arRes['ID'] .
			'\').click(function() {            
	addlog' .
			$arRes['ID'] .
			'.show();
});
</script>'
	);
	$row->AddViewField(
		"receipt_type",
		'<span class="type ' .
			($arRes['RECEIPT_ID'] > 0 ? 'type-success ' : 'type-error ') .
			'type-' .
			strtolower($arRes['RECEIPT_TYPE']) .
			'">' .
			GetMessage('BIFIT_TYPE_' . $arRes['RECEIPT_TYPE']) .
			'</span>'
	);
}

$lAdmin->AddFooter(array(
	array(
		"title" => GetMessage("MAIN_ADMIN_LIST_SELECTED"),
		"value" => $rsData->SelectedRowsCount()
	),
	array(
		"counter" => true,
		"title" => GetMessage("MAIN_ADMIN_LIST_CHECKED"),
		"value" => "0"
	)
));
$lAdmin->AddGroupActionTable(array(
	"delete" => GetMessage("MAIN_ADMIN_LIST_DELETE")
));
$lAdmin->CheckListMode();

require $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/main/include/prolog_admin_after.php";

$lAdmin->DisplayList();

echo '<style type="text/css">table#b_bifit_kassa_reports tr td:nth-child(1),table#b_bifit_kassa_reports tr td:nth-child(2),table#b_bifit_kassa_reports tr td:nth-child(3),table#b_bifit_kassa_reports tr td:nth-child(4),table#b_bifit_kassa_reports tr td:nth-child(7),table#b_bifit_kassa_reports tr td:nth-child(8),table#b_bifit_kassa_reports tr td:nth-child(9),table#b_bifit_kassa_reports tr td:nth-child(10){padding:11px 5px 10px;text-align:center}table#b_bifit_kassa_reports thead tr td{white-space:nowrap}table#b_bifit_kassa_reports tbody tr td.adm-list-table-cell{vertical-align:middle}table#b_bifit_kassa_reports tbody tr td:nth-child(4){color:#1c53a2}a.bifit_update_btn{color:#3f4b54!important}span.error{font-weight:700;letter-spacing:.1em;color:red}span.success{font-weight:700;letter-spacing:.1em;color:#228b22}span.type{padding:4px 10px;border-radius:4px;color:#fff;background:#008000}span.type-error{opacity:.5}span.type.type-sale{background:#228b22;color:#fff}span.type.type-sale_return{background:#90ee90;color:#000}span.type.type-purchase{background:#789;color:#fff}span.type.type-purchase_return{background:#b0c4de;color:#000}</style>';

require $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/main/include/epilog_admin.php";